'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
var Q = require('q');
function applyUpdate(updates) {
    return function (entity) {
        if (!entity)
            return;
        var updated = entity.merge(updates);
        return updated.save()
            .then(function (result) {
            return result;
        });
    };
}
exports.applyUpdate = applyUpdate;
function applyPatch(patch) {
    return function (entity) {
        console.log('----- entity ----');
        console.log(entity);
        if (!entity)
            return;
        console.log(JSON.stringify(patch));
        var def = Q.defer();
        return entity.patch(patch);
        //   , function callback(err) {
        //   if(err) {
        //     console.log(err);
        //     Q.reject(err)
        //   }
        //   console.log('ok');
        //   Q.resolve('ok')
        // })
        // return def.promise.then((result) => {
        //   console.log('----- result ----');
        //   console.log(result);
        //   return result;
        // });
    };
}
exports.applyPatch = applyPatch;
function removeEntity() {
    return function (entity) {
        if (!entity)
            return;
        return entity.remove()
            .then(function (removed) {
            return removed;
        });
    };
}
exports.removeEntity = removeEntity;
function createEntity(model) {
    return function (entity) {
        return model.create(entity);
    };
}
exports.createEntity = createEntity;
function findEntityById(model, id) {
    return model.findById(id)
        .exec();
}
exports.findEntityById = findEntityById;
